# OAI UDM Installation Guide

## Files organization
- `src/`: Source code and related external libs.
- `etc/`: Config file.
- `scripts/`: Build script.
- `ext/`: External code that needs to be installed beforehand (nlohmann/json).
- `README.md`: Installation guide.


## Installation

### System OS Required: Ubuntu 18.04 LTS

First, download Openxg-UDM source code.
```bash
git clone http://git.opensource5g.org/openxg/udm
cd udm
git checkout udm-secu
```
Step 2, install libraries.
```bash
sudo apt-get install cmake curl git libboost-all-dev libconfig++-dev libcurl4-gnutls-dev libgmp-dev libspdlog-dev  nettle-dev   
```
Step 3, install nlohmann/json from source.
```bash
#git clone https://github.com/nlohmann/json ./ext/json
cd ext/json
mkdir build
cd build
cmake ../
make 
sudo make install
sudo ldconfig
```
Once the libraries are installed, in order to compile and run the server please follow the steps below:
```bash
cd ../../../scripts/
./build_udm
```
Once compiled, configure the server:
```bash
cd ../etc
vim udm.conf
```


Once configured, run the server:

```bash
cd ../build
./udm -c ../etc/udm.conf -o -r
```

